#include "serialization.h"
#include <filesystem>
#include <QFile>
#include <QJsonDocument>
#include <QJsonArray>
#include <QJsonObject>

UserList loadUserList(const QString &file)
{
    QFile doc{std::filesystem::path{file.toStdString()}};
    QString fileContents = doc.readAll();

    QJsonParseError errors;
    QJsonDocument document =
        QJsonDocument::fromJson(fileContents.toUtf8(),
        &errors);

    if (document.isNull())
    {
        qDebug() << errors.errorString();
        throw std::runtime_error{"Could not parse JSON file"};
    }

    QJsonArray array = document.array();
    QVector<User> container;

    for (auto elem: array)
    {
        auto obj = elem.toObject();
        User newUser{obj["name"].toString(), QDate::fromString(obj["date_of_birth"].toString()),
                     QDate::fromString(obj["date_of_death"].toString()), obj["default"].toBool()};

        container.append(newUser);
    }

    return container;
}

void saveUserList(const UserList &list)
{

}
